# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator 1.0.0.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ARM::Insights
  module Models
    #
    # The scheduling constraints for when the profile begins.
    #
    class RecurrentSchedule

      include MsRestAzure

      # @return [String] the time zone for the hours of the profile. See
      # examples of valid timezone ids over here:
      # https://msdn.microsoft.com/en-us/library/azure/dn931928.aspx
      attr_accessor :time_zone

      # @return [Array<String>] the collection of days that the profile takes
      # effect on. Possible values are Sunday through Saturday.
      attr_accessor :days

      # @return [Array<Integer>] A collection of hours that the profile takes
      # effect on. Values supported are 0 to 23 on the 24-hour clock (AM/PM
      # times are not supported).
      attr_accessor :hours

      # @return [Array<Integer>] A collection of minutes at which the profile
      # takes effect at.
      attr_accessor :minutes


      #
      # Mapper for RecurrentSchedule class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          required: false,
          serialized_name: 'RecurrentSchedule',
          type: {
            name: 'Composite',
            class_name: 'RecurrentSchedule',
            model_properties: {
              time_zone: {
                required: false,
                serialized_name: 'timeZone',
                type: {
                  name: 'String'
                }
              },
              days: {
                required: false,
                serialized_name: 'days',
                type: {
                  name: 'Sequence',
                  element: {
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              hours: {
                required: false,
                serialized_name: 'hours',
                type: {
                  name: 'Sequence',
                  element: {
                      required: false,
                      serialized_name: 'NumberElementType',
                      type: {
                        name: 'Number'
                      }
                  }
                }
              },
              minutes: {
                required: false,
                serialized_name: 'minutes',
                type: {
                  name: 'Sequence',
                  element: {
                      required: false,
                      serialized_name: 'NumberElementType',
                      type: {
                        name: 'Number'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
