# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator 1.0.0.0
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ARM::Logic
  module Models
    #
    # Model object.
    # 
    #
    class AS2SecuritySettings

      include MsRestAzure

      # @return [Boolean] The value indicating whether to send or request a
      # MDN.
      attr_accessor :override_group_signing_certificate

      # @return [String] The name of the signing certificate.
      attr_accessor :signing_certificate_name

      # @return [String] The name of the encryption certificate.
      attr_accessor :encryption_certificate_name

      # @return [Boolean] The value indicating whether to enable NRR for
      # inbound encoded messages.
      attr_accessor :enable_nrr_for_inbound_encoded_messages

      # @return [Boolean] The value indicating whether to enable NRR for
      # inbound decoded messages.
      attr_accessor :enable_nrr_for_inbound_decoded_messages

      # @return [Boolean] The value indicating whether to enable NRR for
      # outbound MDN.
      attr_accessor :enable_nrr_for_outbound_mdn

      # @return [Boolean] The value indicating whether to enable NRR for
      # outbound encoded messages.
      attr_accessor :enable_nrr_for_outbound_encoded_messages

      # @return [Boolean] The value indicating whether to enable NRR for
      # outbound decoded messages.
      attr_accessor :enable_nrr_for_outbound_decoded_messages

      # @return [Boolean] The value indicating whether to enable NRR for
      # inbound MDN.
      attr_accessor :enable_nrr_for_inbound_mdn


      #
      # Mapper for AS2SecuritySettings class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          required: false,
          serialized_name: 'AS2SecuritySettings',
          type: {
            name: 'Composite',
            class_name: 'AS2SecuritySettings',
            model_properties: {
              override_group_signing_certificate: {
                required: false,
                serialized_name: 'overrideGroupSigningCertificate',
                type: {
                  name: 'Boolean'
                }
              },
              signing_certificate_name: {
                required: false,
                serialized_name: 'signingCertificateName',
                type: {
                  name: 'String'
                }
              },
              encryption_certificate_name: {
                required: false,
                serialized_name: 'encryptionCertificateName',
                type: {
                  name: 'String'
                }
              },
              enable_nrr_for_inbound_encoded_messages: {
                required: false,
                serialized_name: 'enableNrrForInboundEncodedMessages',
                type: {
                  name: 'Boolean'
                }
              },
              enable_nrr_for_inbound_decoded_messages: {
                required: false,
                serialized_name: 'enableNrrForInboundDecodedMessages',
                type: {
                  name: 'Boolean'
                }
              },
              enable_nrr_for_outbound_mdn: {
                required: false,
                serialized_name: 'enableNrrForOutboundMdn',
                type: {
                  name: 'Boolean'
                }
              },
              enable_nrr_for_outbound_encoded_messages: {
                required: false,
                serialized_name: 'enableNrrForOutboundEncodedMessages',
                type: {
                  name: 'Boolean'
                }
              },
              enable_nrr_for_outbound_decoded_messages: {
                required: false,
                serialized_name: 'enableNrrForOutboundDecodedMessages',
                type: {
                  name: 'Boolean'
                }
              },
              enable_nrr_for_inbound_mdn: {
                required: false,
                serialized_name: 'enableNrrForInboundMdn',
                type: {
                  name: 'Boolean'
                }
              }
            }
          }
        }
      end
    end
  end
end
